CON  'Mouse Driver test.
  'Trying to make work with logitech mouse

CON  'This is serial output code posted by mindrobots in the forum
        SYS_CLK = 80_000_000
        BAUDRATE = 3_000_000'115_200
        BAUD_RATE = 3_000_000'115_200 
        nco_baud = round(float($1_0000) / (float(sys_clk) / float(baudrate)))
        bits = 8

        
        RX_PIN = 63
        TX_PIN = 62

        Mailbox1=$FFF80
        Mailbox2=$FFF81


        Sniff_Cog=2

dat  ''Start of serial output code
        orgh    0



        org     0
cog_entry
        coginit #Sniff_COG,#@Sniff_init


SerialMonitorOrg
                pinsetm pm_tx,  #TX_PIN      'set asynchronous tx mode in smart pin 
                pinsetx ##$8000_0000 | nco_baud << 16 | %1_00000 | bits-1, #TX_PIN      'set tx bit period

                pinsetm pm_rx,  #RX_PIN      'set asynchronous rx mode in smart pin 
                pinsetx ##$8000_0000 | nco_baud << 16 | %1_00000 | bits-1, #RX_PIN      'set rx bit period

                setb    dirb, #TX_PIN

                setedg  #%01_000000+RX_PIN     'trigger on smart pin
                jmp   #loopback
                                       '
pm_tx          long               %0000_0000_00_0_0000000000000_01_11110_0        'async tx byte mode, dir high
pm_rx          long               %0000_0000_00_0_0000000000000_01_11111_0        'async rx byte mode, dir low, inputs pin 0

 
bitper          long    (SYS_CLK/BAUD_RATE)<<16+7                       'number of clocks per bit period, 3..65536
xm               long    0
ym               long    0
zm               long   0
im              long    0
                
'*******************************************************
'********* TEST CODE - PUT YOUR CODE HERE **************
' ***** try some input/output
loopback

                'Look for command
                rdbyte  tx_cmd, rx_target                
                cmp     tx_cmd,#0 wz, wc
        if_e    jmp     #loopback


                'check for write byte command
                cmp     tx_cmd,#1 wz,wc
        if_e    rdbyte  tx_char,hex_target        
        if_e    call    #send_char

                'check for write hex long
                cmp     tx_cmd,#2 wz,wc
        if_e    rdlong  tx_hex, hex_target               
        if_e    call    #send_LongHexSub
                

                'check for write hex byte
                cmp     tx_cmd,#3 wz,wc
        if_e    rdbyte  tx_hex, hex_target               
        if_e    call    #send_ByteHexSub

                'check for write string byte
                cmp     tx_cmd,#4 wz,wc
        if_e    rdlong  tx_hex, hex_target               
        if_e    call    #send_StringSub        

                wrbyte  #0,rx_target 'message received and processed
                jmp     #loopback

Send_StringSub 'send a string
                rdbyte  tx_char,tx_hex
                cmp     tx_char,#0 wz,wc
        if_z    ret
                'mov     tx_char,#"B"
                call    #send_char
                add     tx_hex,#1
                jmp     #Send_StringSub
                                
                
Send_LongHexSub  'Send 8 hex chars
                getnib  tx_temp,tx_hex,#7
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#6
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#5
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#4
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#3
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#2               
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#1
                call    #SendHexSub
                getnib  tx_temp,tx_hex,#0
                call    #SendHexSub
                ret

Send_ByteHexSub
              'mov tx_hex,#$AA
                push    tx_hex
                'getnib  tx_temp,tx_hex,#1
                mov     tx_temp,tx_hex
                shr     tx_temp,#4
                and     tx_temp,#$0F
                call    #SendHexSub
                pop     tx_hex
                'getnib  tx_temp,tx_hex,#0
                mov     tx_temp,tx_hex
                and     tx_temp,#$0F
                call    #SendHexSub
                ret
                                               
SendHexSub 'Send hex
                mov     tx_char,tx_temp

                cmp     tx_char,#9 wz,wc
        if_a    add     tx_char,#"A"-10
        if_be   add     tx_char,#"0"
                call    #Send_Char
                ret 
                        
  {              cmp     tx_char,#10  wz,wc
        if_b    add     tx_char,#"0"
        if_b    call    #Send_Char
                cmp     tx_char,#10  wz,wc
        if_b    ret
                sub     tx_char,#10
                add     tx_char,#"A"
                call    #Send_Char
                ret
   }                                       

'********* TEST CODE - REPLACE WITH YOUR CODE ***********
'********************************************************

'*******************************************************************************
' Get one character from the input port.
' Input none
' Changes parm, temp, temp1, temp2
' Output parm
'*******************************************************************************

rcv_char                  
                setedg  #%0_10_000000 | RX_PIN          'select negative edge on p63

                polledg                         'clear edge detector
                waitedg                         'wait for start bit

                waitx   bit_time                'wait for middle of 1st data bit

                rep     @.rep,#8                'ready for 8 bits
                testb   inb,#RX_PIN     wc      'sample rx
                rcr     rx_char,#1              'rotate bit into byte
                waitx   bit_time        'wait for middle of nth data bit
.rep
                shr     rx_char,#32-8           'justify received byte
                ret


'*******************************************************************************
' Output a single character to the tx_pin.
' executes in COG mode
' Input: txchar - character to be sent
' Changes parm, temp1, temp2
' Output none             
'*******************************************************************************
{
send_char
                pinsety tx_char,#TX_PIN  'send  character
send_char_wait
                pingetz temp,#TX_PIN
                testb   temp,#31 wz,wc    
         if_nz  jmp #send_char_wait
                cmp 0,0 wz,wc
                ret  wz,wc
 }                             
send_char       pingetz temp,#tx_pin wc                   'wait if busy
        if_c    jmp     #send_char
                pinsety tx_char,#tx_pin
                ret wz,wc


bit_time        long    SYS_CLK / BAUD_RATE
rx_target       long    Mailbox1
hex_target      long    Mailbox2
tx_cmd          res     1
tx_char         res     1
tx_hex          res     1
timer           res     1
rx_char         res     1
tx_temp         res     1
temp            res     1             
                fit     $1F0


'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CON
  'If D+ is high pin and D- is low pin, then idle should be %10
  'First K should be %01
  
DAT  'Sniff Init
Sniff_init
              org
              
              mov       x2,#6
Starting
              mov       y2,#1
InitDelay    'Show initial message over serial          
              call      #Wait1SecSub
              djnz      y2,#InitDelay

              mov       tx_out,#"X"
              call      #OutputCharSub

              mov       tx_out,#"v"
              call      #OutputCharSub

              mov       tx_out,x2
              call      #OutputByteSub

              mov       tx_out,##@StartMessage
              call      #OutputStringSub
              djnz      x2,#Starting

test2
              mov       dirb,#0
              pinsetm   pm_usb,#PinDP      '#33 configure DP pin (passive)
              pinsetm   pm_usb,#PinDM      '#32 configure DM pin (the brain)
              pinsetx   baud,#PinDM        'configure 1.5Mbps

              mov       dirb,#3


'wait for device to be plugged in
WaitPlug
              pingetz    x2,#PinDM
              testb      x2,#0 wc
    if_nc     jmp       #WaitPlug
              waitx     ##100000
              
test1
              'Scope shows SE0 for 60ms then idle 20ms then SE0 60ms then some data

              'reset usb
              'pinsety   #1,#PinDM  'SE0
              mov       x2,#1
              call      #TransmitByte              
              mov       tx_out,#">"
              call      #OutputCharSub
              waitx     ##4_800_000

              
              'pinsety   #0,#PinDM  'IDLE              
              mov       x2,#0
              call      #TransmitByte              

              mov       tx_out,#"*"
              call      #OutputCharSub
              waitx     ##40_000    '500us=40k

              'jmp       #test1 
            
              pinsety   #1,#PinDM  'SE0
              mov       tx_out,#">"
              call      #OutputCharSub
              waitx     ##4_800_000
              pinsety   #0,#PinDM  'IDLE              
              mov       tx_out,#"*"
              call      #OutputCharSub
              waitx     ##0_040_500
              
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
              jmp       #InitMouse
'Canned USB transmission data
'(Commented ones were for Amazon, but Logitech ones work too)
'(only real difference is different address assigned)
'Get Device Descriptor
Setup         long      3,$2D,$00,$10
GetDeviceD    long      11,$C3,$80,$06,$00,$01,$00,$00,$40,$00,$DD,$94
GetDeviceD2   long      11,$C3,$80,$06,$00,$01,$00,$00,$12,$00,$E0,$F4
'Setup2        long      3,$2D,$1D,$40
Setup2        long      3,$2D,$1A,$38
InPacket      long      3,$69,$00,$10
'InPacket2     long      3,$69,$1D,$40
InPacket2     long      3,$69,$1A,$38
Ack           long      1,$D2
Out0          long      3,$E1,$00,$10
'Out2          long      3,$E1,$1D,$40
Out2          long      3,$E1,$1A,$38   
EmptyData     long      3,$4B,$00,$00
'SetAddress    long      11,$C3,$00,$05,$1D,$00,$00,$00,$00,$00,$E9,$79
SetAddress    long      11,$C3,$00,$05,$1A,$00,$00,$00,$00,$00,$E8,$CE
'Poll9D        long      3,$69,$9D,$F0
Poll9D        long      3,$69,$9A,$88
SetConfig     long      11,$C3,$00,$09,$01,$00,$00,$00,$00,$00,$27,$25
InBuffer      long      4,5,2,1,$a,0[80]
InBytes       long      0 

DAT 'InterPacketDelay sub
InterPacketDelay
              waitx     ##650  'force end of last packet by waiting 
WaitIdle1
              pingetz   x2,#PinDM        'get status into x
              testb     x2,#0 wc
        if_nc jmp       #WaitIdle1
               
              'send idle
              mov       x2,#0
              call      #TransmitByte
              RET


DAT 'SendPacket Sub
SendPacket 'Set source before calling
              mov       i2,0-0  'source gets set before calling
              sets      SendByte,SendPacket 'copy source to loop
              add       SendByte,#1  'look at next long in table

              call      #InterPacketDelay
              'mov       x2,#0
              'call      #TransmitByte              
                 
              'Send SOP
              mov       x2,#$80
              call      #TransmitByte
              
SendByte
              mov       x2,0-0
              add       SendByte,#1
              call      #TransmitByte
              djnz      i2,#SendByte

WaitEOP
              call      #RxByte
              testb     x2,#5 wc
        if_nc jmp       #WaitEOP
                      
              RET              

WaitAck
              testb   inb,#0 wc      'wait for byte received (lower pin)
        if_nc jmp     #WaitAck
              pinack    #PinDM             'ack lower pin             
              pingetz   x2,#PinDM        'get status into x2
              ror       x2,#8
              and       x2,#$FF
              cmp       x2,#$D2 wc,wz
        if_nz jmp       #WaitAck
              RET           

DAT 'Get Packet
GetPacket
              setd      RxWrite,#InBuffer
WaitSOP
              call      #RxByte
              and       x2,#$FF
              'cmp       x2,#$A0 wz,wc
              testb     x2,#4 wc
        if_nc jmp       #WaitSOP
     '   if_ne jmp       #WaitSOP
              mov       i2,#0
RxBytes
              call      #RxByte
              testb     x2,#5 wc
        if_c  mov       InBytes,i2 'Save # bytes received              
        if_c  RET 
              ror       x2,#8
RxWrite
              mov       InBuffer,x2
              add       RxWrite,##1<<9        
              add       i2,#1
              jmp       #RxBytes
        

                      
              
RxByte
.wait3        testb     inb,#0 wc      'wait for byte received (lower pin)
        if_nc jmp       #.wait3   
              pinack    #PinDM             'ack lower pin             
              pingetz   x2,#PinDM        'get status into x2
              RET        

DAT 'init Mouse
InitMouse              
              'Send Setup
              mov       x2,#1  'SeO
              call      #TransmitByte
              waitx     ##50
              mov       x2,#0
              call      #TransmitByte
              waitx     ##5000

              sets      SendPacket,#Setup
              nop
              nop            
              call      #SendPacket
              sets      SendPacket,#GetDeviceD
              nop
              nop            
              call      #SendPacket
              call      #WaitAck 

              mov       y2,#3  
GetBytesLoop
              sets      SendPacket,#InPacket
              nop
              nop         
              call      #SendPacket
              call      #GetPacket
              cmp       InBytes,#1 wz,wc
        if_e  jmp       #GetBytesLoop  'This was a NAK, so try again
              sets      SendPacket,#Ack
              nop
              nop                 
              call      #SendPacket
              djnz      y2,#GetBytesLoop

              'Ouput empty data
              sets      SendPacket,#Out0
              nop
              nop         
              call      #SendPacket
              sets      SendPacket,#EmptyData
              nop
              nop         
              call      #SendPacket
              call      #WaitAck

              

'Set Address              
              'waitx     ##5000
              sets      SendPacket,#Setup
              nop
              nop            
              call      #SendPacket
              sets      SendPacket,#SetAddress
              nop
              nop            
              call      #SendPacket
              call      #WaitAck                                        
SetAdd
              sets      SendPacket,#InPacket
              nop
              nop         
              call      #SendPacket
              call      #GetPacket
              cmp       InBytes,#1 wz,wc
        if_e  jmp       #SetAdd  'This was a NAK, so try again              
              sets      SendPacket,#Ack
              nop
              nop                 
              call      #SendPacket
 
'Get device descriptor from address $1D
              sets      SendPacket,#Setup2
              nop
              nop            
              call      #SendPacket
              sets      SendPacket,#GetDeviceD2
              nop
              nop            
              call      #SendPacket
              call      #WaitAck 

              mov       y2,#3  
GetBytesLoop2
              sets      SendPacket,#InPacket2
              nop
              nop         
              call      #SendPacket
              call      #GetPacket
              cmp       InBytes,#1 wz,wc
        if_e  jmp       #GetBytesLoop2  'This was a NAK, so try again              
              sets      SendPacket,#Ack
              nop
              nop                 
              call      #SendPacket
              djnz      y2,#GetBytesLoop2

              'Ouput empty data
              sets      SendPacket,#Out2
              nop
              nop         
              call      #SendPacket
              sets      SendPacket,#EmptyData
              nop
              nop         
              call      #SendPacket
              call      #WaitAck

              
              
'Set Configuration
              sets      SendPacket,#Setup2
              nop
              nop            
              call      #SendPacket
              sets      SendPacket,#SetConfig
              nop
              nop            
              call      #SendPacket
              call      #WaitAck
SetConfig2
              sets      SendPacket,#InPacket2
              nop
              nop         
              call      #SendPacket
              call      #GetPacket
              cmp       InBytes,#1 wz,wc
        if_e  jmp       #SetConFig2  'This was a NAK, so try again
              sets      SendPacket,#Ack
              nop
              nop                 
              call      #SendPacket              
                                        
              'jmp       #DisplayPacket 'test   
PollMouse
              waitx     ##100000'400_000
              sets      SendPacket,#Poll9D
              nop
              nop            
              call      #SendPacket
              call      #GetPacket              
              cmp       InBytes,#1 wz,wc              
        if_be jmp       #PollMouse
              sets      SendPacket,#Ack
              nop
              nop                 
              call      #SendPacket
              
              'waitx     ##200_000         
              
                                                       
              
DisplayPacket                    
              sets      DisplayLoop,#InBuffer
              nop
              nop
DisplayLoop
              'alti      0,#%000_011_000 'increment destination
              mov       tx_out,InBuffer
              add       DisplayLoop,#1
              call      #OutputByteSub
              djnz      InBytes,#DisplayLoop

              mov       tx_out,#13
              Call      #OutputCharSub
              jmp       #PollMouse
                                       
end1
              jmp       #end1
{             
              
              'pinsety   #$80,#PinDM
              mov       x2,#$80
              call      #TransmitByte          
              'pinsety   #$2D,#PinDM
              mov       x2,#$2D
              call      #TransmitByte
              'pinsety   #$00,#PinDM
              mov       x2,#$00
              call      #TransmitByte
              'pinsety   #$10,#PinDM
              mov       x2,#$10
              call      #TransmitByte
              
              
              'Send Data0
              waitx     ##1300   '650 works
              mov       x2,   #$80
              call      #TransmitByte          
              mov       x2,   #$C3
              call      #TransmitByte              
              mov       x2,   #$80
              call      #TransmitByte              
              mov       x2,   #$06
              call      #TransmitByte                           
              mov       x2,   #$00
              call      #TransmitByte          
              mov       x2,   #$01
              call      #TransmitByte
              mov       x2,   #$00
              call      #TransmitByte
              mov       x2,   #$00
              call      #TransmitByte              
              mov       x2,   #$40              
              call      #TransmitByte          
              mov       x2,   #$00
              call      #TransmitByte              
              mov       x2,   #$DD
              call      #TransmitByte                           
              mov       x2,   #$94
              call      #TransmitByte
             
              'Send IN

              waitx     ##5000
              mov       x2,#$80
              call      #TransmitByte
              mov       x2,#$69
              call      #TransmitByte
              mov       x2,#$00
              call      #TransmitByte
              mov       x2,#$10
              call      #TransmitByte

               
              'pinsety   #4,#PinDM  'EOP

              'waitx     ##100000
              'jmp       #test1             

              'mov       tx_out,#"1"
              'call      #OutputCharSub 
}
              'Wait for incoming response
              'pinack  #PinDM             'ack lower pin 
              mov       i2,#25
WaitStart
          'wait for SOP
.wait           testb   inb,#0 wc      'wait for byte received (lower pin)
        if_nc   jmp     #.wait                           
                pinack  #PinDM             'ack lower pin             
                pingetz x2,#PinDM        'get status into x
              'See if SOP
              testb     x2,#4 wc

              'mov       tx_out,x2
              'call      #OutputByteSub 
    '    if_nc jmp       #WaitStart

        'Now, wait for data or EOP
             'mov       j2,#1 'First byte should be 1 in bit 7
StartSniff
.wait2        testb   inb,#0 wc      'wait for byte received (lower pin)
        if_nc   jmp     #.wait2

              'mov       tx_out,#"3"
              'call      #OutputCharSub 
              
              pinack    #PinDM             'ack lower pin             
              pingetz   x2,#PinDM        'get status into x2
              ror       x2,#8
              mov       tx_out,x2
              call      #OutputByteSub
              
              djz       i2,#MouseDone
              jmp       #StartSniff 

              
              
MouseDone
              waitx     ##500000 
              jmp       #test1 
              jmp       #MouseDone


TransmitByte
              'rev       x2,x2
              'rol       x2,#8
              pinsety   x2,#PinDM
              'waitx     #10
WaitUpperIn               
              testb     inb,#PinDP wc
        if_nc jmp       #WaitUpperIn
              pinack    #PinDP
              ret
                            
              
              

StartCapture
{
              'Wait for period of no activity on USB
              mov       i2,#0  
WaitPause
              mov       x2,inb
              and       x2,#%1100  'isolate USB copy pins
              ror       x2,#2
              cmp       x2,#%01 wz,wc '%10 wz,wc  'Reversing this for swapped DM/DP
        if_e  add       i2,#1
        if_ne mov       i2,#0
              cmp       i2,##100 wz,wc     '10,000 was too much
        if_ae jmp       #PauseFound                                          
              jmp #WaitPause
PauseFound
}
              'prepare to write fast
              wrfast    #0,##SniffData
              mov       i2,##5000

              'mov       tx_out,#">"
              'call      #OutputCharSub
{               
WaitStart
          'wait for SOP
'This cog will do pingetz, usb cog will do the pinack
.wait           testb   inb,#0 wc      'wait for byte received (lower pin)
        if_nc   jmp     #.wait


              'mov       tx_out,#"B"
              'call      #OutputCharSub

                            
                pinack  #PinDM             'ack lower pin             
                pingetz x2,#PinDM        'get status into x
                'mov     outa,x
              'See if SOP
              testb     x2,#4 wc
    '    if_nc jmp       #WaitStart

        'Now, wait for data or EOP
              mov       j2,#1 'First byte should be 1 in bit 7
StartSniff
.wait2        testb   inb,#0 wc      'wait for byte received (lower pin)
        if_nc   jmp     #.wait2

              
              
              pinack  #PinDM             'ack lower pin             
              pingetz x2,#PinDM        'get status into x
              wfword    x2

              djz       i2,#ShowData
  '            sub       i2,#1
  '            cmp       i2,#0 wz,wc
  '      if_z  jmp       #ShowData
              jmp       #StartSniff            
        
   '           testb   x2,#5 wc 'see if EOP
   '     if_c  jmp       #WaitStart  'wait for next packet
   '           jmp       #StartSniff
}

ShowData
              'clear screen
              waitx     ##1000000
              mov       tx_out,#0
              'call      #OutputCharSub
                  
              mov       tx_out,##@CapturedMessage
              call      #OutputStringSub
              

              mov       i2,##5000
              mov       y2,##SniffData 
              rdfast    #0,##SniffData

                                   
ShowDataLoop  

              'Show status of actual DP,DM and also INA for DP and DM
             ' rflong    x2

              rfword    x2
              djz       i2,#DoneSniff
              mov       y2,x2 'save
              ror       x2,#8

              'Now, going to output bytes as groups
              testb     y2,#4 wc 'SOP check, see if new byte
        if_nc jmp       #ShowDataLoop    'wait for SOP as sign of packet start
              jmp       #GetNextByte     'Next byte will be valid data

ShowPacketByte
              mov       tx_out,x2
              call      #OutputByteSub
              mov       tx_out,#" "
              call      #OutputCharSub

GetNextByte              
              rfword    x2
              djz       i2,#DoneSniff

              mov       y2,x2
              ror       x2,#8 
              testb     y2,#5 wc 'see if EOP
        if_nc jmp       #ShowPacketByte
              mov       tx_out,#13
              call      #OutputCharSub
              jmp       #ShowDataLoop 'EOP so wait for new packet
             
              djnz      i2,#ShowDataLoop                                        
 
DoneSniff              
              jmp       #DoneSniff  'StartCapture'DoneSniff              

DAT 'variables
tx_target     long      Mailbox1  'Mailbox for serial output
tx_hexTarget  long      Mailbox2  'Mailbox for Hex output
tx_out        long      0   'holds character to output
tx_cnt        long      0
x2             long      0
y2             long      0
i2             long      0
j2             long      0
k2             long      0
timer1         long      0
flag2         long      0

DAT 'USB settings
pm_usb          long    %1_11000_0 'low speed host %0_11010_0 'low speed device
baud            long    1228'1.5 MBPS
flag            long    0

DAT 'OutputCharSub
OutputCharSub   'Output character in tx_out
              wrbyte    tx_out,tx_hexTarget 'set byte to send 
              wrbyte    #1,tx_target 'send command #1
OutputCharWait
              rdbyte    tx_out,tx_target
              cmp       tx_out,#0 wc,wz
        if_nz jmp       #OutputCharWait              
              ret wz,wc 
DAT 'OutputLongSub
OutputLongSub   'Output long in tx_out as hex, setting MSB to make sure non-zero
              wrlong    tx_out,tx_hexTarget
              wrbyte    #2,tx_target 'send command #2
              jmp       #OutputCharWait

DAT 'OutputByteSub
OutputByteSub   'Output long in tx_out as hex, setting MSB to make sure non-zero
              wrlong    tx_out,tx_hexTarget
              wrbyte    #3,tx_target 'send command #3
              jmp       #OutputCharWait

DAT 'OutputStringSub
OutputStringSub    'Output a string at provided HUB location
              wrlong    tx_out,tx_hexTarget
              wrbyte    #4,tx_target 'send command #4
              jmp       #OutputCharWait

DAT 'wait 1 sec
Wait1SecSub    'wait one second
              GETCT   tx_cnt               'get initial CNT
              ADDCT1  tx_cnt,##80_000_000          'make initial CT1 target
              WAITCT1                 'wait for CT1 target
              ret


              fit              
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CON  'Start of USB section
  Messages=$1000 'storage for string messages
  SniffData=$2000
  PinDP=33
  PinDM=32

   

DAT 'variables
x             long      0
y             long      0
DAT 'Messages
              orgh Messages
StartMessage  byte      13,13,13,13,"Starting USB Mouse Interface.",13,0
Pause1Message byte      13,"Pause Found",13,0
CapturedMessage byte      13,"USB data captured",13,0 

DAT 'SniffData  (where sniffed data will be stored)
              orgh SniffData